Program Halozat;
{Ertekel a HALOZAT feladathoz}
Uses TestLib;
{Importlt elemek:
TCase:Integer;           a tesztesetek szma
Function DoTest:Boolean; a teszteset rtkelhet, van output fjl
Procedure Done;          az rtkels vgnek jelzse
Procedure Grade(rf, v:Integer); az rf rszfeladat rtklse, v=0/1
                                ha nem hvjuk, 0 rtket kap a teszeset
Procedure WriteMSG(rf:Integer; M:String); az rf rszfeladat rtkelsnekmagyarzata
            ha nem hvjuk, resen marad
TInF:Text;  teszt input, megnyitva
ToutF:Text; teszt output, megnyitva
CoutF:Text; a versenyz output llomnya, megnyitva
}
Var
  t:Integer;

Procedure Eval;
Const
  MaxN=10000;
  Null=0;
Type
  Szinek=(Feher, Szurke, Fekete);
  Pont=1..MaxN;
  List=^Cell;
  Cell=Record P:Pont; link:List End;
  Graph=Array[1..MaxN] Of List;
  Sor=Array[1..MaxN] Of 0..MaxN;
Var
  G:Graph;      {input graph}
  N,M:Longint;     {# graph Ponts}
  Szin:Array[Pont] of Szinek;
  KorBen:Array[Pont] Of Boolean;
  Apa:Array[Pont] Of 0..MaxN+1;
  D,BeFok:Array[Pont] Of 0..MaxN;
  S:Sor;
  Meg1,Meg2,VMeg1,VMeg2:Longint;
  x,y,u,v,i:Longint;
  p,Guv:List;
  Ido:Longint;
  
Procedure Sor12;
Var i:Longint;
  x:Longint;
Begin{Sor12}
  {$I-}
     ReadLn(CoutF, VMeg1);
  {$I+}
   If IOResult<>0 Then Begin
     WriteMSG(1,'HIBA: Output formtum hiba');
     ReadLn(CoutF);
     Exit;
   End;
   If Meg1<>VMeg1 Then Begin
     WriteMSG(1,'HIBA: A helyes eredmeny '+InttoStr(Meg1)+' es nem '+InttoStr(VMeg1));
     ReadLn(CoutF);
     Exit;
   End;
  Grade(1,1);
  WriteMSG(1,'HELYES');

  For i:=1 To Meg1 Do Begin
    If SeekEoLn(CoutF) Then Begin
        WriteMSG(2,'HIBA: kevesebb szmot r ki');
        ReadLn(CoutF);
        Exit;
      End;
    {$I-}
       Read(CoutF, x);
    {$I+}
      If IOResult<>0 Then Begin
        WriteMSG(2,'HIBA: Output formtum hiba');
        ReadLn(CoutF);
        Exit;
      End;
    If (x<1)Or(x>N) Then Begin
        WriteMSG(2,'HIBA: hibs csompontszm: '+InttoStr(x));
        ReadLn(CoutF);
        Exit;
      End;
    If Not KorBen[x] Then Begin
        WriteMSG(2,'HIBA: '+InttoStr(x)+' krben van');
        ReadLn(CoutF);
        Exit;
      End;
    KorBen[x]:=False;
  End{for i};
  For i:=1 To N Do If Korben[i] Then Begin
    WriteMSG(2,'HIBA: '+InttoStr(x)+' krben van');
    ReadLn(CoutF);
    Exit;
  End;
  ReadLn(CoutF);

  Grade(2,1);
  WriteMSG(2,'HELYES');
End{Sor12};

Procedure Szamol;
Var
  u,x:Pont;

  Procedure MelyBejar(u:Pont);
  {Global: Apa, Korben, Befok}
  Var
    El:List;
    v,w,fel:Pont;
  Begin
    Inc(Ido);
    D[u]:=Ido;
    Szin[u]:=Szurke;
    fel:=u;
    El:=G[u];
    While El<>Nil Do Begin{processing edge u->v }
      v:=El^.p;
      If Szin[v]=Feher Then Begin{u->v is a tree edge}
        Apa[v]:=u;
        Inc(BeFok[u]);
        MelyBejar(v);
      End Else If (v<>Apa[u])and(Szin[v]=Szurke) Then Begin  {u->v is a back edge}
        If D[v]<D[fel] Then Begin
          w:=fel;
          While (w<>v) Do begin
            KorBen[w]:=True;
            w:=Apa[w];
          End;
          KorBen[v]:=True;
          fel:=v;
        End;
      End;
      El:=El^.link;
    End{while u->v};
    Szin[u]:=Fekete;
    If D[fel]<D[u] Then Korben[u]:=True;
  End{MelyBejar};
Begin{Szamol}
  For u:=1 To N Do Begin
    Szin[u]:=Feher;
    Apa[u]:=0; {init}
    KorBen[u]:=False;
    BeFok[u]:=0;
  End;
  Apa[1]:=Null;
  Ido:=0;
  
  MelyBejar(1);    {}
End{Szamol};

Procedure Sor34;
Var i:Longint;
  x,y:Longint;
Begin{Sor34}
  {$I-}
     ReadLn(CoutF, VMeg2);
  {$I+}
   If IOResult<>0 Then Begin
     WriteMSG(3,'HIBA: Output formtum hiba');
      Exit;
   End;
   If Meg2<>VMeg2 Then Begin
     WriteMSG(3,'HIBA: A helyes eredmeny '+InttoStr(Meg2)+' es nem '+InttoStr(VMeg2));
     Exit;
   End;
  Grade(3,1);
  WriteMSG(3,'HELYES');

  For i:=1 To Meg2 Do Begin
    {$I-}
       ReadLn(CoutF, x, y);
    {$I+}
     If IOResult<>0 Then Begin
        WriteMSG(4,'HIBA: Output formtum hiba');
        Exit;
     End;
     If (x<1)Or(x>N)Or(y<1)Or(y>N)Or(x=y) Then Begin
        WriteMSG(4,'HIBA: hibs j vonal: '+InttoStr(x)+' '+InttoStr(y));
        Exit;
      End;
    New(Guv);
    Guv^.p:=y; Guv^.link:=G[x];
    G[x]:=Guv;
    New(Guv);
    Guv^.p:=x; Guv^.link:=G[y];
    G[y]:=Guv;
  End{for i};

  Szamol;

  For i:=1 To N Do If Not Korben[i] Then Begin
    WriteMSG(4,'HIBA: '+InttoStr(i)+' nincs krben.');
    Exit;
  End;

  Grade(4,1);
  WriteMSG(4,'HELYES');
End{Sor34};

Begin{Eval}
  ReadLn(Tinf,N,M);
  For u:=1 To N Do Begin       {Init}
    G[u]:=Nil;
    Korben[u]:=False;
  End;

  ReadLn(ToutF,Meg1);
  For i:=1 To Meg1 Do Begin
    Read(ToutF,x);
    Korben[x]:=True;
  End;
  ReadLn(ToutF);
  Sor12;
    
  ReadLn(ToutF,Meg2);
  For i:=1 To M Do Begin       {Read input}
    ReadLn(TInF, u,v);
    New(Guv);
    Guv^.p:=v; Guv^.link:=G[u];
    G[u]:=Guv;
    New(Guv);
    Guv^.p:=u; Guv^.link:=G[v];
    G[v]:=Guv;
  End{for i};
  Sor34;
  For i:=1 To N Do Begin 
    Guv:=G[i];
    While Guv<>Nil Do Begin
      p:=Guv;
      Guv:=p^.link;
      Dispose(p);
    End{while};
  End;
End{Eval};

Begin{Prog}
  For t:=1 To TCase Do Begin
    If DoTest Then
      Eval;
  End;
  Done;
End.
